---
title: History.state
slug: Web/API/History/state
tags:
  - API
  - HTML DOM
  - History
  - History API
  - Property
  - Reference
---
<div>{{APIRef("History API")}}</div>

<p><span class="seoSummary">The <strong><code>History.state</code></strong> property returns a value representing the state at the top of the history stack.</span> This is a way to look at the state without having to wait for a {{event("popstate")}} event.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>currentState</em> = history.state</pre>

<h3 id="Value">Value</h3>

<p>The state at the top of the history stack. The value is {{jsxref("null")}} until the {{domxref("History.pushState","pushState()")}} or {{domxref("History.replaceState","replaceState()")}} method is used.</p>

<h2 id="Examples">Examples</h2>

<p>The code below logs the value of <code>history.state</code> before using the {{domxref("History.pushState","pushState()")}} method to push a value to the history. The next line logs the value to the console again, showing that <code>history.state</code> now has a value.</p>

<pre class="brush: js">// Should be null because we haven't modified the history stack yet
console.log(`History.state before pushState: ${history.state}`);

// Now push something on the stack
history.pushState({name: 'Example'}, "pushState example", 'page3.html');

// Now state has a value.
console.log(`History.state after pushState: ${history.state}`);</pre>

<h2 id="SpecificationsE">Specifications<a class="button section-edit only-icon" href="/en-US/docs/Web/API/History$edit#Specifications" rel="nofollow, noindex"><span>E</span></a></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#dom-history-state", "History.state")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "browsers.html#dom-history-state", "History.state")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.History.state")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/History_API/Working_with_the_History_API">Working with the History API</a></li>
</ul>
